changequote(`{',`}')
changecom({;})
define({__BYTE_ORDER},1234)
include({magic.m4})

; Boot Record for TUNES.
; Copyright (c) Franois-Ren "Far" Bn Rideau Dang-Vu 1994

; Read the info/BIOS-API.nfo file (section * bootrec.asm::).


;;; Defines that may change.
SYS_SIZE	 =  0x07C0	; Total system (loader+api+kernel) size in para
				; For use by LILO or LOADLIN.
LOADER_SEG_SIZE	 =  0x0F00	;(60KB) ; size in para for the loader segment.
				; here I assumed there were more than 128 KB of
				; main memory :-)
LOADER_SECTS	 =  4			; size of the loader in sectors.
LOADER_OFFSET	 =  0x100		; load the loader as a .COM file.
KERNEL_SECTS	 =  15			; Size of Kernel+API to load.
CONTIGUOUS	 =  1			; put API+Kernel just after previous.

define({__OEM_ID__},{"TUNES-01"})	; nice name, isn't it ?
define({__DISK_TYPE__},{1440KB_Floppy})	; also (HIDDEN_)1722KB_floppy



;;; Defines that won't change
LOADER_STACK_TOP =  LOADER_SEG_SIZE*16+M_LenFDREAD
					; SP in the same segment.
BOOT_OFFSET	=	0x7C00		; Where the BIOS loads the boot code
LOG_SECT_SIZE	=	9		; Size of sectors (low-level standard)
SECT_SIZE	=   1 << LOG_SECT_SIZE	; 512



ifelse(__DISK_TYPE__,{1440KB_Floppy},{

;;; Defaults for a standard 1.4MB bootdisk
;RESERVED_SECTS	=	1+LOADER_SECTS	; loader is in reserved sectors.

define(D_T_NUM_SECT,2880)		; 1.4 MB floppy
;SECT_P_CLU	=	1		; we use only a few files, so
					; let's reduce the FAT overhead.
NUMBER_FATS	=	2		; Macro-Shit DOS needs 2
;ROOTDIR_ENTRIES	=	0xE0		; 32, 2 sectors
MEDIA_DESCRPTR	=	0xF0		; High Density Floppy
;SECTS_PER_FAT	=	9		; Compute yourself ;
SECTS_IN_TRACK	=	18		; Yes, sir
NUMBER_HEADS	=	2		; 2 sides ;
D_HIDDEN_SECTS	=	0		; no partitioning on floppies
;LOAD_MODE	=	'D		; see below
COMMANDLINE_OFS =	8192
},

__DISK_TYPE__,{HIDDEN_1722KB_Floppy},{
; (1722-1440)=282, so that VirusOS shouldn't be larger than that.
; That's 564 sectors, including all the Windows worming code ;
; of course, we can compress.
;   The problem is with the user seeing what's happening, so we must go
; multithreading real soon, so we cangive the hand back to the user;
; then, if a reboot is requested, we run the bootstrap loader in
; VM86 mode, with a no I/O mode, until we get some int 13h call with the
; right value [Argh ; The BIOS uses hardware interrupts, so that'll be
; difficult to tune]
}})


;;; Automatic definition after the remaining stuff.
ifelse(eval(D_T_NUM_SECT < 0x10000),0,
{  T_NUM_SECT	=	0},
{  T_NUM_SECT	=	D_T_NUM_SECT
   ;; Linux-ish Command-line interface
   ;; D_T_NUM_SECT	=	(0xA33F | (COMMANDLINE_OFS << 16))
})


; LOAD_MODE is:
; 'D for loading a DOS file as the API+Kernel
; 'H for using a 1722 KB disk's hidden sectors as the Loader+API+Kernel
; 'C for using contiguous directories just after the boot record and the
;     loader itself.
; 'L is set directly by the loader.
if CONTIGUOUS
 RESERVED_SECTS	=	1+LOADER_SECTS+KERNEL_SECTS
 LOAD_MODE	=	'C
 LOAD_ARG	=	1+LOADER_SECTS
endif

;;; CUSTOM:
NUMBER_FATS = 2
SECTS_PER_FAT = 2
SECT_P_CLU = 8
ROOTDIR_ENTRIES = 32

define({jmps},{jmp})


undefine(DEBUG_INT_13)

ifdef({DEBUG_INT_13},
{
DEBUGINT = 0x15

define({BreakPoint},{
	;push ax
	;mov ax,#0x00FF
 ;int DEBUGINT
	;pop ax
})

define({INT_13},{
   ;; Debug code
	;pusha
	;les di,[0x13*4]
	;call PutAddr
	;call CRLF
	;popa
   ;; Do call
	;;int #0x13	; usual definition
	pushf
	cli
	callf [0x13*4]
})
},
{
define({BreakPoint},{})
define({INT_13},{int #0x13})
})
		.text
		.org	0	; actually, BIOS jumps to 0:7C00, but I could
				; not link properly without putting org 0x0 for
				; a .BIN or org 0x100 for a .COM. Thus, Beware
				; to add BOOT_OFFSET to every reference in this
				; segment.
		use16
;entry start
.globl _main
_main:
;start:
		cld			; let's use this opcode space ;
		jmps	over_tables	; leave space for DOS disk info.

;;; DOS info. table
		.org	0x03
OEM_Id:		.ascii	__OEM_ID__	; 0x03 - Whatever name you like.
		.org	0x00B
bytes_per_sect:	.word	SECT_SIZE	; 0x0B - 512 is the low-level standard.
sectors_per_clu:.byte	SECT_P_CLU	; 0x0D - do not fragment too much.
reserved_sect:	.word	RESERVED_SECTS	; 0x0E - boot record is among them.
num_FATs:	.byte	NUMBER_FATS	; 0x10
entries_rootdir:.word	ROOTDIR_ENTRIES	; 0x11
total_num_sect:	.word	T_NUM_SECT	; 0x13 - 1.4 MB.
media_descr:	.byte	MEDIA_DESCRPTR	; 0x15 - 3.5" DS HD floppy.
sect_per_FAT:	.word	SECTS_PER_FAT	; 0x16 - follows from the above
sect_per_track:	.word	SECTS_IN_TRACK	; 0x18 - number of sectors per track
num_heads:	.word	NUMBER_HEADS	; 0x1A - number of heads
hidden_sect:	.long	D_HIDDEN_SECTS	; 0x1C - number of hidden sectors.
d_total_n_sect:	.long	D_T_NUM_SECT	; 0x20 - defined for HD if > 65535
;		.word	0		; ???? dunno if needed. MS has it.

;;; TUNES Loading Parameters
		.org	0x24		; should be 0x2C or 0x3E, saiz LILO
	; !!! Beware ; Install script currently relies on it being 0x24.
LoadMode:	.byte	LOAD_MODE	;
LoadArg:	.word	LOAD_ARG	;
BIOS_DL:	.byte	0		; On what disk is the loader ?

; Here is a list of BIOS parameters for sectors to load, ended with
;; an entry where AL=0 (DH and CX will be loaded)

;; First entry
BIOS_CX:	.word	2		; CH:cyl&0xFF, CL:sect+((cyl>>8)<<6)
BIOS_AL:	.byte	LOADER_SECTS	; int 13 parameters to load the LOADER
BIOS_DH:	.byte	0		; head
;; End Marker
		.long	0
		.long	0,0,0		; up to seven chunks, all in all.
;;; Strings

sBooting:	.byte	13,10
		.ascii	"Booting"
		.ascii	" "
sTUNES:	.ascii	"TUNES"
sdots:		.ascii	"."
		.byte	0
;sReboot: 	.byte	13,10
;		.ascii	"Hit any key to reboot"
;		.byte	0
;;; Globals
;;_Putc:	.word	cPutc + BOOT_OFFSET
;;define({Putc},{_Putc+BOOT_OFFSET})
define({Putc},{cPutc})

define({PUTC},{
	ifelse($1,{},,{mov al,char})
	call	Putc
})


; Notes:
; * hidden_sect is number of sectors on physical disk before boot sector.
; * d_total_n_sect is used for partitions with more than 65535 sectors;
;  total_num_sect is then null. For some hard disks, set it even if <10000h.


;;;;;;;;;;;;;;;;;;;;;;;;;; Actual boot code ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  over_tables:		; interrupts are disabled just in case of.

   ;;; First of all, Init cs and ds to 0000h
		;PUTC('X)
		xor	ax,ax
		mov	ds,ax
		push	ax
		mov	bx,#Here_I_am + BOOT_OFFSET
		push	bx
		retf


  Here_I_am:
   ;;; Show that we got there.
	; Int 10 doesn't work under console mode dosemu, but
	; works under tty mode dosemu, because of VGA ROM ;;;
	; A 'RETF' only ROM has it work (without cursor, but it works ;)

	; Init text mode, cursor appearance, cursor position
	ifelse({
		;PUTC('Y)
		mov	ax,#0x0003	; 80x25, 16 colors
		int	#0x10
		mov	ah,#0x01	; cursor appearance
		mov	cx,#0x0B0C
		int	#0x10
		mov	ah,#0x02	; cursor position in page 0
		mov	bh,#0
		mov	dx,#0000
		int	#0x10
	})
		mov	si,#sBooting + BOOT_OFFSET
		call	Puts

   ;;; Init space for .COM loader.
	; Get Top of conventional memory in AX
		int	#0x12
		mov	cx,#0x0406		; put size in para into ax
		shl	ax,cl
		sub	ax,#LOADER_SEG_SIZE	; get LOADER SEG address.
		mov	es,ax

	ifelse({
	;;; allow debugging
		;mov (DEBUGINT*4),#NewIntDebug-M_OFFSET_FDREAD
		;mov (DEBUGINT*4+2),es
	})

	; Init stack for .COM loader
		cli				; DI, for 8088's
		mov	ss,ax
		mov	sp,#LOADER_STACK_TOP
		sti				; EI back.
	; push near return address to 0 & put "INT 19" reboot instruction at 0
	; so that ret LOADER termination will reboot the computer
		cld	;(just in case int 12 destroyed it)
		xor	di,di
		push	di
		mov	ax,#0x19CD
		stosw
	; Init command line arguments
		seg	es
		movb	[0x80],#0x99		; line length >= 128, hehe ;
		mov	si,#BOOT_OFFSET+02	; move the DOS info table
		mov	cx,#0x3F		; move 63 words (=126 bytes)
		rep
		movsw				; di=2 already

   ;;; Install the FDRead utility.
	; save the old int 13 handler address
		mov	ax, [0x13*4]
		mov	[old13_ofs+ BOOT_OFFSET], ax
		mov	[u_old13_ofs+ BOOT_OFFSET], ax
		mov	ax, [0x13*4+2]
		mov	[old13_seg+ BOOT_OFFSET], ax
		mov	[u_old13_seg+ BOOT_OFFSET], ax
	; save the old int 19 handler address
		mov	ax, [0x19*4]
		mov	[old19_ofs+ BOOT_OFFSET], ax
		mov	ax, [0x19*4+2]
		mov	[old19_seg+ BOOT_OFFSET], ax
	; move the new handler to its working address (top of memory)
		mov	si, #NewInt13 + BOOT_OFFSET
		mov	di, #LOADER_STACK_TOP
		mov	cx, #LenFDREAD	; I could't divide it by 2 ;;;
		cld		; (int 13 and int 10 may have spoilt it)
		rep
		movsb		; so no movsw
	; write the new addresses
		mov	[0x13*4], #LOADER_STACK_TOP+NewInt13Entry-NewInt13
		mov	[0x13*4+2], es
		mov	[0x19*4], #LOADER_STACK_TOP+UnInstall13-NewInt13
		mov	[0x19*4+2], es

   ;;; Load the rest of the loader into the .COM segment.
     ;* Note that if we use less than say 62 KB, that memory top is divisible
     ;* by 64KB, and that BIOS hook programs use less than 2K, we won't cross
     ;* a DMA 64KB boundary, so that everything is fine
	; Reset the Floppy disk controller (MS and linux do it, so I do too ;)
		xor	ax,ax
		mov	dl,[BIOS_DL+BOOT_OFFSET]
		INT_13
	; Init the buffer to the .COM file.
		mov	bx,#0x0100	;(es:bx points to the .COM entry point)
	; Push it as far return address (so that retf'll later jumps into it)
		push	es
		push	bx
	; Init registers for loading the LOADER (hehe)
		mov	si,#BIOS_CX+BOOT_OFFSET
	; Do Load the LOADER, chunk by chunk

Do_Load:	mov	al,#'.		; print that a chunk is being processed
		call	Putc
		cld			; just in case
		lodsw
		mov	cx,ax
		lodsw
		mov	dh,ah
		mov	dl,[BIOS_DL+BOOT_OFFSET]
		or	al,al
		jz	Done
		push	si
		push	ax
		mov	ah,#2
		INT_13		; no error checking: if the boot sector was
				; successfully loaded, why should an I/O
				; problem occur ?
		pop	ax		; length
		pop	si
		;xor	ah,ah		; not needed: SECTOR_SIZE >= 256
		mov	cl,#LOG_SECT_SIZE ; sector to bytes
		shl	ax,cl
		add	bx,ax
		jmps	Do_Load

	; jump into it
Done:
	;	xor	ax,ax		; Init .COM registers ;
	;	mov	cx,bx
	;	dec	ch
	;	xor	bx,bx
	;	xor	dx,dx
	;	xor	si,si
	;	xor	di,di

		mov	cx,#16
		mov	di,#0x100
		push	es
		pop	ds
		retf

;;; DIE for debugging
; die:		call	Beep
;		jmps	die

;;;;;;;;;;;;;;;;; Int 13 handler from the FDFORMAT package ;;;;;;;;;;;;;;;;;;;

.align 2
NewInt13:

M_OFFSET_FDREAD	=	NewInt13 - LOADER_STACK_TOP
; hack, hack, hack, hack and hack...


NewInt13Entry:
   ;;; Only modify behavior for functions Read(2), Write(3), Verify(4), when
   ;;; a floppy is used.
ifelse({
		push	es
		push	ax
		mov	ax,#0xB800
		mov	es,ax
		seg	es
		mov	[0],0xF40
		pop	ax
		pop	es
})
		BreakPoint
		;call	DumpRegs
		or	ah,ah		; reset ?
		jz	donothing	; yes: exit
		cmp	ah,#4		; above Read, Write, Verify ?
		ja	donothing	; No: exit
		cmp	dl,#3		; floppy ?
		ja	donothing	; No: exit
   ;;; Save registers
		BreakPoint
		push	ax	; request
		push	bx	; buffer
		push	ds	; user's data seg
		xor	bx,bx
		mov	ds,bx
   ;;; Disk-Parameter Table in DS:BX, 4: max. num of sectors per track
		lds	bx,[0x78]
		mov	al,[bx+4]
		seg	cs
		mov	[oldsec-M_OFFSET_FDREAD],al	; old in oldsec
		movb	[bx+4],#0x1B			; new value: 25
   ;;; Do not modify track 0
		BreakPoint
	;	or	ch,ch			;Track 0 ?
	;	jz	exit			;Yes, exit
   ;;; Restore registers
		pop	ds	; user's ds
		pop	bx	; buffer
		pop	ax	; request
		BreakPoint
   ;;; call the old Int 13 handler.
		push	ax	; save request
		pushf		; push flags to call an interrupt routine
		push	cs
		call	jmp_old13
   ;;; On error, analyze.
		jnc	okexit		;No problem, so exit
		pop	ax		;restore ax
		push	ds		;save ds & bx
		push	bx
		mov	bx,#0x40	;init ds to BIOS-Data Segment...
		mov	ds,bx
		mov	bl,#0x90	;Beginning of the Drive-Table
		add	bl,dl		;Offset des Laufwerks (?) ; dl=disk#
		cmp	ch,#43			;Track>43 ?
		ja	nodstep			;Ja,dann niemals DSTEP
		xorb	[bx],#0x20		;invert the Stepper Bit
		jmps	stepend			;End the Stepping
nodstep:	andb	[bx],#0xdf		;Kein Double-Stepping
stepend:	pop	bx			;restore ds, bx
		pop	ds
		jmps	endrout2		;Routine zu Ende

exit:		pop	ds			;restore ds,bx,ax
		pop	bx
		pop	ax
endrout2:	pushf
	;;; call old int 13 handler
endrout:	push	cs
		call	jmp_old13
		;was: seg cs ; call [old13-M_OFFSET_FDREAD]
okexit:	
	;;; restore max. sects/track
		push	bx
		push	ds
		xor	bx,bx
		mov	ds,bx
		lds	bx,[0x78]	;Disk-Parameter Table in DS:BX
		movb	[bx+4],#0x1B
;;		.org	. - 1	; hack, hack, hack
;;oldsec:		.byte	0x1B
oldsec1:
oldsec		=	oldsec1 - 1
		pop	ds
		pop	bx
	;;; Return to the caller
		inc	sp		;pop off the request
		inc	sp
		retf	#2		;Exit, dropping original Flags

donothing:
;;; Hack, hack, hack
jmp_old13:	BreakPoint
		.byte	0xea	; jmp	far 0:0
old13:
old13_ofs:	.word	0	; Offset
old13_seg:	.word	0	; Segment

NewIntDebug:	iret

UnInstall13:	xor	ax,ax
		mov	ds,ax
		mov	[0x13*4],#1234
		__old13_ofs__:
		u_old13_ofs	= __old13_ofs__-2
		mov	[0x13*4+2],#1234
		__old13_seg__:
		u_old13_seg	= __old13_seg__-2
		mov	[0x19*4+0],#1234
		__old19_ofs__:
		old19_ofs	= __old19_ofs__-2
		mov	[0x19*4+2],#1234
		__old19_seg__:
		old19_seg	= __old19_seg__-2
		int #0x19

		.align 2
FDRD_BLen:	.word	LenFDREAD-4
		.long	MAGIC_MARKER

NewIntEnd:
M_LenFDREAD	=	NewInt13 - NewIntEnd
LenFDREAD	=	NewIntEnd - NewInt13




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Subroutines ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Puts:
; Adapted from MicroSoft's own boot sector
; DS:SI=ASCIIZ string to print
; AX spoilt, SI points just after the string-ending zero, 7 put into BX.
	lodsb
	or	al,al
	jz	Return
	call	Putc
	jmps	Puts

ifelse({
Beep:
; echo a BEEP to the the Console
	mov	al,#7
;	jmps	cPutc
})

; Outputs a character to console
; spoils AX and DI, keeps si
cPutc:
	push	bx
	push	si
	push	di
	push	es
	mov	ah,#0xE	; function Teletype
	mov	bx,#7	; attribute
	int	#0x10	; Video BIOS call
	pop	es
	pop	di
	pop	si
	pop	bx
Return:
	ret

ifelse({
CRLF:
	mov	al,#13
	call	Putc
	mov	al,#10
	jmp	Putc

Space:
	mov al,#' '
	jmp Putc
})

ifelse({
DumpRegs:
	push ss
	push ds
	push es
	push cs
	pusha
	call CRLF
	mov di,sp
	sub di,#10
	mov cx,#20
	call PutWZone
	call CRLF
	popa
	pop es
	pop es
	pop ds
	pop ss
	ret


PutWZone:
	seg es
	mov ax,[di]
	inc di
	inc di
	push cx
	push di
	call PutHexWord
	call Space
	pop di
	pop cx
	loop PutWZone
	ret

PutZone:
	seg es
	mov al,[di]
	inc di
	push cx
	push di
	call PutHexByte
	call Space
	pop di
	pop cx
	loop PutZone
	ret

PutAddr:
;; Prints the contents of es:di
	push di
	mov ax,es
	call PutHexWord
	mov al,#':
	call Putc
	pop di
	mov ax,di
;	jmp PutHexWord

; Prints the contents of AX in hexa.
; saves AX, puts 4 into CL
PutHexWord:
	xchg al,ah
	call PutHexByte
	xchg al,ah
;	jmp PutHexByte

; Prints the contents of AL in hexa.
; saves AX, puts 4 into CL, 7 into BX
PutHexByte:
	push cx
	mov cl,#4
	rol al,cl
	call PutHexNybble
	rol al,cl
	pop cx
;	jmp PutHexNybble

; Prints to BIOS console the hexa nybble in low AL
; saves AX, puts 7 into BX
PutHexNybble:
	push ax
	and al,#0xF
	add al,#'0
	cmp al,#0xA+'0
	jb do_putnyb
	add al,#'A-'0-0xA
 do_putnyb:
	call Putc
	pop ax
	ret
})

ifelse({
Getc:
	xor ah,ah
	int #0x16
	ret

sPutc:
	stosb
	ret

; From Linux:
; * This procedure turns off the floppy drive motor, so
; * that we enter the kernel in a known state, and
; * don't have to worry about it later.
kill_motor:
	push dx
	mov dx,#0x3f2
	xor al,al
	out dx,al
	pop dx
	ret
})
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; THE END: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Space for The Partition table (?)
;		.org 0x1BE
;		.word 0x40 dup (0)
;;; Linux kernel signature:
		.org 0x1F1		; just before 0x200 (=512)
loadersects:	.byte	LOADER_SECTS
root_flags:	.word	1
kernel_size:	.word	SYS_SIZE	; size in para for LILO/LOADLIN
swap_dev:	.word	0
ram_size:	.word	0
vid_mode:	.word	-1
root_dev:	.word	0x0200
;;; Bootable sector signature:
boot_flag:	.word	0xAA55		; beware the order: 55,AA

;;; The boot sector is exactly 0x200 (512) bytes long.
