
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Constants ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Orig_PM_Target_seg = PMPARTCS
Orig_PM_Target_ofs = pmaddr(PM_Entry_Point)
Orig_RM_Target_ofs = rmaddr(RM_Return_Point)



rminit

define({stringaddr},{$1})


__dataseg__({
;;;;;;;;;;;;;;;;;;;;;;;;;; Initialization Data ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.align 4
Orig_GDT:
 DefDescriptor(0,0x00000,0x00,0x00)				; NULL
 DefDescriptor(0,0xFFFFF,0x9A,0x50)				; TEMPSEG
 DefDescriptor(0,0xFFFFF,0x9A,0xD0)				; ALLMEMCS
 DefDescriptor(0,0xFFFFF,0x92,0xD0)				; ALLMEMDS
 DefDescriptor(rmpart_end-0x10000,0xFFFF,0x9A,0x10)		; RMPARTCS
 DefDescriptor(rmpart_end-0x10000,0xFFFF,0x92,0x10)		; RMPARTDS
 DefDescriptor(pmpart_end,0xFFFFF,0x9A,0xD0)			; PMPARTCS
 DefDescriptor(pmpart_end,0xFFFFF,0x92,0xD0)			; PMPARTDS
;Orig_GDT_Len = $-Orig_GDT
Orig_GDT_Len = 65536
})



__udataseg__({
;;;;;;;;;;;;;;;;;;;;;;;;;;;; Uninitialized Data ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RMPart_seg:	.word	0	; where the RM Part is to be put.

})



__codeseg__({
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;; API Entry/Exit Points ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

entry API_Entry_Point

API_Entry_Point:

; Called by the boot loader.
; must be far away from the top of conventional memory.
; * Entry:
;  CS,DS,ES,SS point to the API group of segments
;  the COMMAND_LINE is below APIOFS, the API offset.
;  SP is below the COMMAND_LINE. (!)Beware, it's below 768 bytes
;  arguments are pushed on the stack: see below

; * Never exits, but launches TUNES.

	__("Initializing the BIOS-based API.",CRLF)


;;; Init Console

; Print Init Message
	PUTS("Welcome to TUNES.",CRLF)

; Set the keyboard repeat rate to the max
	mov ax,#0x0305
	clr(bx)
	int #0x16


;;; Get parameters from the LOADER
	; Get CPU type
	pop word [CPUType]

	; Get available conventional memory
	pop eax
	mov dword [AvConvMem],eax

	; Get total conventional memory
	pop dword [ConvMem]

	; Get available/total extended memory
	pop dword [XtdMem]

	; Get command line
	; (nothing to do; loader put it at COMMAND_LINE, zero-ended)
	zzz({
	  pushad
	  PUTS("Command line is:",CRLF)
	  mov si,#COMMAND_LINE
	  PUTS
	  call PrCRLF
	  popad
	})

;;; Initialize some variables
	sidt [rm_idt_address]
	zWZonez({"IDT: "},cs,rm_idt_address,3,{CRLF})

;;; Move the Real-Mode Part to where it belongs
   ;;; determine the destination segment
	shr eax,#4
	sub ax,#0x1000		; 64 KB in para
	mov [RM_Part_seg],ax
	mov [RM_Target_seg],ax
   ;;; do move
	mov si,#rmpart_actbeg
	mov es,ax
	mov di,#rmaddr(rmpart_actbeg)
	mov cx,#(rmpart_actlen+3)/4
	cld
	rep
	movsd

;;; Continue there...
	mov ds,ax
	push ax
	push #rmaddr(There)
	retf
})
rminit
__codeseg__({

There:
	__("Here I am up in RM part !",CRLF)


;;; Go in protected mode as soon as possible:
;;; everything is so much easier from there

; Prepare landing
	;.....

; Jump into the Protected Mode
	STEP(4)
	__("Let's jump into protected mode !",CRLF)
	br GoProtect	; original (unmoved) version
})



pminit

__codeseg__({

;;;;; And Now, the dreaded entry point ! ;;;;;
PM_Entry_Point:
	movzx esp,sp
	mov eax,#ALLMEMDS
	mov fs,ax
	mov ebx,#0xB8000+2*(38+5*80)
	seg fs
	mov dword [ebx+0],#0x0F750F54
	call sleep_1s
	seg fs
	mov dword [ebx+4],#0x0F650F6E
	call sleep_1s
	seg fs
	mov dword [ebx+8],#0x0F200F73
	STOP(fs,0xB8000,0,0,'P,0x78)
	mov ecx,#5
	call sleep


;;; Move the RM part of the API to where it belongs: up conventional memory,
	;.....


;;; Move the PM part of the API to where it belongs: up extended memory.
	;.....


;;; Print debug message
	mov eax,#ALLMEMDS
	mov fs,ax
	mov ebx,#0xB8000+2*(38+6*80)
	seg fs
	mov dword [ebx+0],#0x0F4F0F4D
	call sleep_1s
	seg fs
	mov dword [ebx+4],#0x0F530F4F
	call sleep_1s
	seg fs
	mov dword [ebx+8],#0x0F200F45
	mov ecx,#5
	STOP(fs,0xB8000,1,0,'M,0x78)
	call sleep

;;; exit back to real mode
	jmpi rmaddr(GoReal), RMPARTCS
})


rmpart

__rminitcode__({

RM_Return_Point:
; Show that we got there
	zzzz({push #0xB800}__nl__{pop es})
	STOP(es,0,13,20,'R,0xC)		; 'R' for RealMode
	STOP(es,0,14,20,'e,0xC)		; 'e' for RealMode
; Try accessing ALLMEMDS through fs.
	STOP(fs,0xB8000,15,20,'A,0xC)	; 'A' for Allmem
	STOP(fs,0xB8000,16,20,'l,0xC)	; 'l' for Allmem
	STOP(fs,0xB8000,17,20,'l,0xC)	; 'l' for Allmem
; Restore segment registers
	push cs
	pop ds
	STOP(es,0,70,9,'B,0xB)		; 'B' for Back
	z_z({"Back in real mode:",CRLF})
	STOP(es,0,71,8,'a,0xB)		; 'a' for Back
	zwoz({"cs="},cs,{CRLF})
	STOP(es,0,72,7,'c,0xB)		; 'c' for Back
; Reenable Interruptions
	call RM_Enable_NMI
	sti
; That's all, folks
	STOP(es,0,73,6,'k,0xB)		; 'k' for Back
	CGETC({CRLF,"Hit any key to reboot."})
	STOP(es,0,73,5,'!,0xB)		; 'k' for Back
	int  #0x19	; reboot
	;jmpi 0xFFFF,0

forget({
Test_Mode:
; This routine has been used instead of RM_Return_Point,
; to prove that returning in real mode from a 32 bit protected mode segment
; made the CPU land in such thing as a 32 bit real mode !!!
; To have it work, copy the GoReal procedure in a 32 bit segment,
; and have it jump into this routine.
; (beware: jump address should be word ofs,word 0,word seg)
; print 'M' indifferently in 32 bit and 16 bit modes
; In both modes, it will print a M white on black on the first character of
; the second line.
; In 32 bit mode, it will also print next to it a blinking {acute E}
; (which corresponds to the nop's 9090h value which is pushed then poped !!!)
	push #0xB800
	nop
	nop
	pop ds
	push #0x74D
	nop
	nop
	xor bx,bx
	push #160
	nop
	nop
	pop dx
	mov bl,dl
	mov di,bx
	pop word [bx]
	hlt		; halt, or the computer may reboot
			; before you see the result.
})

})



__pminitcode__({
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Subroutines ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sleep_1s:
	push ecx
	mov ecx,#0x10000	; 1 M
 s1s:	loop s1s
	pop ecx
	ret

sleep:
	STOP(fs,0xB8000,79,0,'R,0xF0)
	call sleep_1s
	STOP(fs,0xB8000,79,0,'Z,0xF0)
	call sleep_1s
	loop sleep
	ret


Setup_GDT:
	;.......

Setup_LDT:
	;......

Setup_RM_IDT:
	;......
	mov cx,#16
	push ds
	push #0
	pop ds
	;mov ax,#rmaddr(RM_IRQ)
	mov bx,#IRQ_INT_BASE
	shl bx,#2
  SRMI_0:
	mov [bx],ax
	mov [bx+2],cs
	add bx,#4
	add ax,#3
	loop SRMI_0
	pop ds
	ret

Setup_PM_IDT:
	;......

Setup_Paging:
	;......


})
