include({choice.m4})

comment({	Portable implementation of the LLL kernel	})

comment({	The choice constructs will select the best	})
comment({	implementation ;-)				})


forget({
   Whenever a common interface can be found, move everything
from choices to macros defined in specialization files.
})


__codeseg__({


comment({----- Integer Arithmetics -----})


DefWord(R-,RSUB)
	Enter
	Sub(TOS,point(DSP))
	Add(DSP,CELL)
	Next


DefWord(-,SUB)
	Neg(TOS)


DefWord(+,ADD)
	Enter
	Add(TOS,point(DSP))
	Add(DSP,CELL)
	Next


DefWord(2/,SHR)
	Enter
	Shr(TOS,1)
	Next


DefWord(>>,SHRN)
	Enter
	Mov(COUNT,TOS)
	PopData(TOS)
	Shr(TOS,COUNTLO)
	Next


DefWord(NEGATE)
	Enter
  Neg0:
	Neg(TOS)
	Next


DefWord(ABS)
	Enter
choice({
    option({generic},{
	gotons(TOS,Next0)
    })
    option({i386},{
	Neg(TOS)
	;Mov(eax,TOS)
	;CDQ
	;Xor(eax,edx)
	;Sub(eax,edx)
	;Mov(TOS,eax)
    })
    option({ANSIC},{
	if(TOS<0){TOS=-TOS};
    })
})
	Next


DefWord(1+,INC)
	Enter
	Inc(TOS)
	Next






comment({----- Basic Multiplication operators -----})


DefWord(M*,m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,point(DSP))
	imul TOS
	Mov(point(DSP),eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        dcell Prod = TOS * point(DSP) ;
	Mov(point(DSP),(cell)Prod) ;
	Mov(TOS,(cell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(UM*,u_m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,point(DSP))
	mul TOS
	Mov(point(DSP),eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        udcell Prod = TOS * point(DSP) ;
	Mov(point(DSP),(cell)Prod) ;
	Mov(TOS,(cell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(SM/REM,s_m_slash_rem)
	Clr(edx)
	Mov(eax,point(DSP))
	idiv(TOS)
	Mov(point(DSP),eax)
	Mov(TOS,edx)
	Next


DefWord(UM/MOD,u_m_slash_mod)
	Enter
	Mov(edx,TOS)
	Pop(eax)
	Pop(TOS)
	
	Pop(edx)
	Pop(eax)
	Clr(edx)
	Mov(eax,point(DSP))
	idiv(TOS)
	Mov(point(DSP),eax)
	Mov(TOS,edx)
	Next






comment({----- Pointer Arithmetics -----})

DefWord(CELL+,CELL_PLUS)
	Enter
	Add(TOS,CELL)
	Next

DefWord(CELLS)
	Enter
	Shl(TOS,CELLABITS)
	Next






comment({----- Integer as boolean arrays Arithmetics -----})

DefWord(NOT)
DefWord(INVERT)
	Enter
	Not(TOS)
	Next

DefWord(AND)
	Enter
	And(TOS,point(DSP))
	Add(DSP,4)
	Next

DefWord(OR)
	Enter
	Or(TOS,point(DSP))
	Add(DSP,4)
	Next

DefWord(XOR)
	Enter
	Xor(TOS,point(DSP))
	Add(DSP,4)
	Next

DefWord(FLAG)
	Enter
choice({
    option({i386},{
	test TOS,TOS
	setnz bl
	movsx TOS,bl
    })
    option({generic},{
	gotoz(TOS,FLAG0)
	TOS=TRUE ;
	FLAG0:
    })
})
	Next


comment({----- USING POINTERS -----})
.......
	CSTK_STO:
			mov eax,point(esi)
			mov point(TOS),eax
			mov TOS,point(esi+4)
			add esi,8
			Next
	CSTK_LOD:
			mov TOS,point(TOS)
			Next
	CSTK_CSTO:
			mov eax,point(esi)
			mov point(TOS),al
			mov TOS,point(esi+4)
			add esi,8
			Next
	CSTK_CLOD:
			xor TOS,TOS
			mov bl,point(TOS)
			Next
	CSTK_WSTO:
			mov eax,point(esi)
			mov point(TOS),ax
			mov TOS,point(esi+4)
			add esi,8
			Next
	CSTK_WLOD:
			xor TOS,TOS
			mov bx,point(TOS)
			Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;; NUMBER COMPARISON ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Equality
	CSTK_0EQ:
			test TOS,TOS
			setz bl
			movsx TOS,bl
			Next
	CSTK_EQ:
			cmp TOS,point(esi)
			sete bl
			movsx TOS,bl
			add esi,4
			Next
	CSTK_0NEQ	=	CSTK_FLAG
	CSTK_NEQ:
			cmp TOS,point(esi)
			setne bl
			movsx TOS,bl
			add esi,4
			Next

;;; Signed number comparison to zero
	CSTK_0LT:
			or TOS,TOS
			setl bl
			movsx TOS,bl
			Next
	CSTK_0LE:
			or TOS,TOS
			setle bl
			movsx TOS,bl
			Next
	CSTK_0GT:
			or TOS,TOS
			setg bl
			movsx TOS,bl
			Next
	CSTK_0GE:
			or TOS,TOS
			setge bl
			movsx TOS,bl
			Next
;;; Signed number comparison
	CSTK_LT:
			cmp point(esi),TOS
			setl bl
			movsx TOS,bl
			add esi,4
			Next
	CSTK_LE:
			cmp point(esi),TOS
			setg bl
			movsx TOS,bl
			add esi,4
			Next
	CSTK_GT:
			cmp point(esi),TOS
			setg bl
			movsx TOS,bl
			add esi,4
			Next
	CSTK_GE:
			cmp TOS,point(esi)
			setge bl
			movsx TOS,bl
			add esi,4
			Next
;;; Unsigned number comparison
	CSTK_ULT:
			cmp TOS,point(esi)
			setb bl
			movsx TOS,bl
			add esi,4
			Next
	CSTK_ULE:
			cmp TOS,point(esi)
			setbe bl
			movsx TOS,bl
			add esi,4
			Next
	CSTK_UGT:
			cmp TOS,point(esi)
			seta bl
			movsx TOS,bl
			add esi,4
			Next
	CSTK_UGE:
			cmp TOS,point(esi)
			setae bl
			movsx TOS,bl
			add esi,4
			Next




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CONSTANTS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Macro def_CSTK_		constant
	CSTK_&constant:
			sub esi,4
			mov point(esi),TOS
			mov TOS,constant
			Next
EndM

	MINUS1 = -1
	MINUS2 = -2
	MINUS4 = -4
	MAXINT = (1 SHL 30) -1
	MININT = - (1 SHL 30)

	num=0
	rept 32
	  def_CSTK_ %num
	  num=num+1
	endm
	def_CSTK_ MINUS1
	def_CSTK_ MINUS2
	def_CSTK_ MINUS4
	def_CSTK_ MAXINT
	def_CSTK_ MININT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;; STACK MANIPULATION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	CSTK_SWAP:
			xchg TOS,point(esi)
;			Next		; not necessary as another Next follows
	CSTK_NOP:
			Next
	CSTK_OVER:
			sub esi,4
			mov point(esi),TOS
			mov TOS,point(esi+4)
			Next
	CSTK_DUP:
			sub esi,4
			mov point(esi),TOS
			Next
	CSTK_PICK:
			mov TOS,point(esi+TOS*4)
			Next
	CSTK_ROT:
			mov eax,point(esi)
			mov point(esi),TOS
			mov TOS,point(esi+4)
			mov point(esi+4),eax
			Next
	CSTK_ROTROT:
			mov eax,point(esi+4)
			mov point(esi+4),TOS
			mov TOS,point(esi)
			mov point(esi),eax
			Next

	CSTK_ROLL:
			mov ecx,TOS
			jecxz CSTK_DROP
			mov TOS,edi
			mov edi,esi
			mov eax,point(esi)
		cstk_roll_0:
			xchg eax,point(edi)
			add edi,4
			loop cstk_roll_0
			mov edi,TOS
;			mov TOS,eax		; DROP follows
;			add esi,4
;			Next
	CSTK_DROP:
			mov TOS,point(esi)
;			add esi,4
;			Next
	CSTK_NIP:
			add esi,4
			Next

	CSTK_ROLLD:
			mov ecx,TOS
			jecxz CSTK_NOP
			mov TOS,point(esi+ecx+4)
			mov eax,point(esi)
		cstk_rolld_0:
			xchg eax,point(esi+ecx*4)
			loop cstk_rolld_0
			add esi,4
			Next
	CSTK_2DROP:
			mov TOS,point(esi+4)
			add esi,8
			Next
	CSTK_2NIP:
			mov TOS,point(esi+4)
			mov eax,point(esi)
			add esi,8
			mov point(esi),eax
			Next
	CSTK_2SWAP:
			xchg TOS,point(esi+4)
			mov eax,point(esi)
			xchg eax,point(esi+8)
			mov point(esi),eax
			Next
	CSTK_2DUP:
			mov eax,point(esi)
			sub esi,8
			mov point(esi),eax
			mov point(esi+4),TOS
			Next
	CSTK_2OVER:
			mov eax,point(esi+8)
			sub esi,8
			mov point(esi),eax
			mov point(esi+4),TOS
			mov TOS,point(esi+12)
			Next


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;; PROGRAM CONTROL, RET-based Threading ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Words with different behaviour when using a control loop
;; for indirect threading or debugging
;; direct threading (no debugging control loop):
;;  point(esp) is just the direct code pointer
;;  point(ebp) is the environment pointer
;; environment is in

	CSTK_R_ENV:
			lea TOS,point(ebp+4*TOS)
			Next

	CSTK_R_IMM:
			sub esi,4
			mov point(esi),TOS
			pop TOS
			Next
	CSTK_R_GOTO:
			mov esp,TOS
			mov TOS,point(esi)
			add esi,4
			Next
	CSTK_R_BRZ:
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
	CSTK_R_BRNZ:
			pop eax
			test TOS,TOS
			jz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
	CSTK_R_BRA:
			pop eax
			add esp,eax
			Next
	CSTK_R_SKIP:
			pop eax
			Next
	CSTK_R_JZ:
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
	CSTK_R_JNZ:
			pop eax
			test TOS,TOS
			jz short CSTK_R_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
	CSTK_R_JMP:
			pop esp
			Next
	CSTK_R_BSR:
			pop eax
			add edi,4
			mov point(edi),esp
			add esp,eax
			Next
	CSTK_R_JSR:
			pop eax
			add edi,4
			mov point(edi),esp
			mov esp,eax
			Next
	CSTK_R_RET:
			mov esp,point(edi)
			sub edi,4
			Next


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;; PROGRAM CONTROL, Bytecode threading ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Words with different behaviour when using a control loop
;; for indirect threading or debugging
;; Indirect threading:
;;  point(esp) is just the usual indirect threading routine
;;  point(ebp) is the bytecode pointer
;; environment is in point(esp+4)

	CSTK_B_ENV:
			mov edx,point(esp+4)
			lea TOS,point(edx+TOS*4)
			Next
	CSTK_B_IMM8:
			sub esi,4
			mov point(esi),TOS
			movzx TOS,point(BYTE ebp)
			inc ebp
			Next
	CSTK_B_IMM16:
			sub esi,4
			mov point(esi),TOS
			movzx TOS,point(WO ebp)
			inc ebp
			Next
	CSTK_B_IMM32:
			sub esi,4
			mov point(esi),TOS
			mov TOS,point(ebp)
			add ebp,4
			Next
	CSTK_B_GOTO:
			mov esp,TOS
			mov TOS,point(esi)
			add esi,4
			Next
	CSTK_B_BRZ:
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
	CSTK_B_BRA:
			pop eax
			add esp,eax
			Next
	CSTK_B_SKIP:
			pop eax
			Next
	CSTK_B_JZ:
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
	CSTK_B_JMP:
			pop esp
			Next
	CSTK_B_BSR:
			pop eax
			sub edi,4
			mov point(edi),esp
			add esp,eax
			Next
	CSTK_B_JSR:
			pop eax
			sub edi,4
			mov point(edi),esp
			mov esp,eax
			Next
	CSTK_B_RET:
			mov esp,point(edi)
			add edi,4
			Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;; EXECUTION CONTROL ;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	CSTK_THREAD:
;			mov point(ebp+SAVE_SS),ss
;			mov point(ebp+SAVE_ESP),esp
;			mov ss,ds
			pop esp
			Next


	EXEC_MANY:
	;; executes ECX kernel instructions pointed at by EBX
			xchg TOS,esi
			mov edx,edi
			lea eax,point(ecx*4)
			sub esp,eax
			mov eax,point(TOS)
			@REPEAT
			  push eax
			  add TOS,4
			  mov eax,point(TOS)
			  or eax,eax
			@UNTIL z
			Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;; MULTITHREADING ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;NOP_CODE = 90h
	;87 DB is xchg TOS,TOS
	RETN_CODE = 0C3h
	DSOVRR_CODE = 3Eh
	ESOVRR_CODE = 26h
	SSOVRR_CODE = 36h
	CSOVRR_CODE = 2Eh
	FSOVRR_CODE = 64h
	GSOVRR_CODE = 65h
	PUSHIMM_CODE = 69h

	CSTK_PAUSE:
		AbsJmp CSTK_YIELD
	CSTK_YIELD:

		mov point(BY CSTK_PAUSE),RETN_CODE


forget({
Not implemented:
#
#>
#S	number
'	tick

})
